/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import java.awt.BorderLayout;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 *
 *  This panel collects configuration related information from user
 * 
 * */
public class ConfigPanel extends JPanel {
	JButton okButton = new JButton("OK");
	JButton cancelButton = new JButton("CANCEL");
	GUI gui = null;
	NNPanel nnPanel = new NNPanel();
	NWSMonitorPanel  nwsPanel = new NWSMonitorPanel();
	ActionListener cancelListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			gui.backToMain();
		}
	};
	ActionListener okListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			gui.setConfig(getConfig());
			gui.backToMain();
		}
	};
	public ConfigPanel(GUI gui){
		this.gui = gui;
		JTabbedPane pane = new JTabbedPane();
		pane.addTab("Neural Network",nnPanel);
		pane.addTab("NWS Monitor",nwsPanel);
		setLayout(new BorderLayout());
		add(pane,BorderLayout.NORTH);
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new BorderLayout());
		JPanel pnl = new JPanel();
		pnl.setLayout(new GridLayout());
		pnl.add(okButton);
		pnl.add(cancelButton);
		buttonPanel.add(pnl);
		add(buttonPanel,BorderLayout.SOUTH);
		cancelButton.addActionListener(cancelListener);
		okButton.addActionListener(okListener);
		revalidate();
		repaint();
		
	}
	
	/**
	 * Assigns the config to panel
	 * @param config
	 */
	public void setConfig(Config config){
		nnPanel.setConfig(config);
		nwsPanel.setConfig(config.nwsMonitorConfig);
	}
	
	/**
	 *  returns configuration created/modified by user
	 * @return config
	 */
	
	public Config getConfig(){
		Config config = nnPanel.getConfig();
		config.nwsMonitorConfig = nwsPanel.getConfig();
		return config;
	}
	 
	
	public static void main(String argv[]){
		   JFrame frame = new JFrame("NN Test");
		   frame.setVisible(true);
		   frame.setSize(500, 500);
		  
		   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		   ConfigPanel nnPanel = new ConfigPanel(null);
		   frame.getContentPane().setLayout(new BorderLayout());
		   frame.getContentPane().add(nnPanel,BorderLayout.CENTER);
		   frame.validate();
	  }
	
}
