/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/

import javax.swing.*;
import java.awt.*;
/**
 *
 * Database configuration panel
 */
public class DBPanel extends JPanel{
	JTextField txtConnStr = new JTextField();
	JTextField txtUserId  = new JTextField();
	JTextField txtPassword = new JTextField();
	JTextField txtDriver = new JTextField();
	JTextField txtStatId = new JTextField();
	
	JLabel lblConnStr = new JLabel("Connection String");
	JLabel lblUserId  = new JLabel("User Id");
	JLabel lblPassword = new JLabel("Password");
	JLabel lblDriver  = new JLabel("Driver");
	JLabel lblStatId = new JLabel("Stat ID");
	
	public DBPanel(){
		setLayout(new GridLayout(5,2));
		add(lblConnStr);
		add(txtConnStr);
		add(lblUserId);
		add(txtUserId);
		add(lblPassword);
		add(txtPassword);
		add(lblDriver);
		add(txtDriver);
		add(lblStatId);
		add(txtStatId);
		setBorder(BorderFactory.createTitledBorder("Data base"));
		setConfig(GUI.DefaultConfig.dbConfig);
		setPreferredSize(new Dimension(300,250));
	}
	
	public String getStatId(){
		return txtStatId.getText();
	}
	
	public void setConfig(DBConfig config){
		txtConnStr.setText(config.connectionString);
		txtUserId.setText(config.userName);
		txtPassword.setText(config.password);
		txtDriver.setText(config.driverName);
		
	}
	
	public DBConfig getConfig(){
		DBConfig config= new DBConfig();
		config.connectionString=txtConnStr.getText();
		config.userName=txtUserId.getText();
		config.password=txtPassword.getText();
		config.driverName=txtDriver.getText();
		return config;
	}
}
