/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import java.io.*;
import java.sql.*;
import java.util.StringTokenizer;

/**
 *
 * This class extracts data from database and creates a file
 * which will be fed into predictor
 */
public class DataExtractor {

	/*
	 * DataExtractor.java
	 *
	 * Created on March 23, 2004, 1:52 PM
	 */
		public static final String DELIM = " ";
		public static final int    COLUMNS = 3;

		public static final String statQuery = "select timestamp, avg_no_of_bits from stat where stat_id=?";
	    private DBConfig config;
	    
		    /** Creates a new instance of DataLoader */
	    public DataExtractor(DBConfig config) {
	    	this.config = config;
	        try{
	            Class.forName(config.driverName);
	        }catch(Exception e){
	            e.printStackTrace();
	        }

	    }
	    
	    public void extract(String statId,String fileName) throws Exception{
			Connection conn  = DriverManager.getConnection(config.connectionString, config.userName, config.password);
			PreparedStatement pstmt = null;
			BufferedWriter writer = new BufferedWriter(new FileWriter(fileName));
			ResultSet rs = null;
			try
			{
				pstmt=conn.prepareStatement(statQuery);
				pstmt.setLong(1, Long.parseLong(statId));
				rs = pstmt.executeQuery();
				while(rs.next())
				{
					String line="";
					line+=(rs.getTimestamp(1).getTime()/1000)+DELIM;
					for(int i=0;i<=3;i++)
					{
						line+=(rs.getTimestamp(1).getTime()/1000)+DELIM;
					}
					line+=rs.getString(2)+DELIM;
					writer.write(line + "\r\n");
				}
						
			}
			catch(Exception e)
			{
				e.printStackTrace();
			}
			finally
			{
				if(rs!=null) rs.close();
				if(writer!=null) writer.close();
			}
			pstmt.close();
			conn.close();
	        
	    }
	    
	    public long toLong(String str){
	       return Long.parseLong(str.trim());
	    }
	    
	    
		public String replace(String str, String from, String to)
		{
			StringTokenizer tok = new StringTokenizer(str, from,true);
			StringBuffer buf = new StringBuffer();
			while(tok.hasMoreTokens())
			{
				String t = tok.nextToken();
				if(t.equalsIgnoreCase(from)){
					buf.append(to);

				}else{
					buf.append(t);
				}
			}
			return buf.toString();
		}
		

	    
	}

