/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;

/**
 *
 * Allows user to specifiy the file by displaying file picker panel
 */
public class FilePanel extends JPanel {
	private JLabel lblFile;
	private JButton btnBrowse;
	private JTextField txtFileName;
	 
	public FilePanel(){
	  JPanel tPanel=new JPanel();
	  setLayout(new BorderLayout());
	  setBorder(BorderFactory.createTitledBorder("File"));
	  lblFile=new JLabel("File:");
	  btnBrowse=new JButton("Browse..");
	  txtFileName = new JTextField();
	  txtFileName.setColumns(20);
	  Insets insets = new Insets(0,0,0,0);
	  tPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
	  tPanel.add(lblFile);
	  tPanel.add(txtFileName);
	  tPanel.add(btnBrowse);
	  add(tPanel,BorderLayout.NORTH);
	  
	  btnBrowse.addActionListener(new ActionListener(){
	  		public void actionPerformed(ActionEvent e) {
	  			JFileChooser fileChooser = new JFileChooser();
	  			int returnVal = fileChooser.showOpenDialog(FilePanel.this);
	  		    if(returnVal == JFileChooser.APPROVE_OPTION) {
	  		    	String fileName =fileChooser.getSelectedFile().getAbsolutePath();
	  		       txtFileName.setText(fileName);
	  		    }

	  		}
	  });
	  setPreferredSize(new Dimension(300,50));
	}
	
	public String getFileName(){
		return txtFileName.getText();
	}
	
	 public static void main(String argv[]){
		   JFrame frame = new JFrame("File Test");
		   frame.setVisible(true);
		   frame.setSize(500, 500);
		  
		   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		   FilePanel filePanel = new FilePanel();
		   frame.getContentPane().setLayout(new BorderLayout());
		   frame.getContentPane().add(filePanel,BorderLayout.CENTER);
		   frame.validate();
	   } //main
}
