/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/

import java.util.*;
import javax.swing.*;

import org.jCharts.Chart;
import javax.swing.event.*; 

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import javax.swing.text.html.*;
/**
 *
 * Creates a monitor screen from nws website
 **/
public class MonitorPanel extends JPanel{
	JEditorPane htmlPane = null;
	JLabel lblTitle = new JLabel("NWS Monitor");
	JButton btnCancel = new JButton("Cancel");
	JButton btnGraph = new JButton("Store to DB");
	private GUI gui = null;
	ResultDataModel dataModel =  null;
	ActionListener cancelListener = new ActionListener(){
		public void actionPerformed(ActionEvent e) {
			gui.backToMain();
		}
	};
	public MonitorPanel(GUI gui){
		this.gui = gui;
		this.revalidate();
		gui.setPreferredSize(new Dimension(600,550));
		
		htmlPane=new JEditorPane();
		htmlPane.setPreferredSize(new Dimension(600,500));
		JScrollPane pane=new JScrollPane(htmlPane);
		pane.setPreferredSize(new Dimension(600,500));
		htmlPane.setEditable(false);
		
		btnGraph.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent evt){
				try{
					htmlPane.setPage("http://nws.cs.ucsb.edu/CGI/graphIt.cgi?target2=nation.cs.wisc.edu%3A8060&nameserver=nmi.cs.ucsb.edu&resource=bandwidthTcp&target=gibson.cs.utk.edu%3A8060&small=no");//"http://nws.cs.ucsb.edu/CGI/graphIt.cgi");
				}catch(Exception e){
					e.printStackTrace();
				}
			}
		});
		
		try{
			htmlPane.setPage("http://nws.cs.ucsb.edu/CGI/graphIt.cgi");
			htmlPane.getDocument().addDocumentListener(new DocumentListener(){
				public void insertUpdate(DocumentEvent e){
					update();
				}
				public void removeUpdate(DocumentEvent e){
					update();
				}
				public void changedUpdate(DocumentEvent e){
					update();
				}
			});
			}catch(Exception e){
			e.printStackTrace();
		}
		/*htmlPane.addActionListener
		(   new ActionListener()
			    {   public void actionPerformed( ActionEvent event )
			        {
			        }
			    }
		);*/
		htmlPane.addHyperlinkListener(new HyperlinkListener(){
			public void hyperlinkUpdate(HyperlinkEvent e){
				System.out.println("hyperlink event called"+e.getEventType().toString()+e.getURL());
				if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
		 		      JEditorPane pane = (JEditorPane) e.getSource();
		 		      if (e instanceof HTMLFrameHyperlinkEvent) {
		 		          HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
		 		          HTMLDocument doc = (HTMLDocument)pane.getDocument();
		 		          doc.processHTMLFrameHyperlinkEvent(evt);
		 		      } else {
		 		          try {
		 			      pane.setPage(e.getURL());
		 		          } catch (Throwable t) {
		 			      t.printStackTrace();
		 		          }
		 		      }
		 	      }
			}
		});
		//tblResults.setModel(dataModel);
		setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
		c.insets=new Insets(5, 5, 5, 5);
		c.gridx = 0; c.gridy=0;
		c.gridwidth=GridBagConstraints.REMAINDER;
		c.gridheight=1;
		add(lblTitle,c);
		 c.gridy=1;
		c.gridheight=20;
		add(pane,c);
		c.gridheight=1;
		JPanel btnPanel = new JPanel();
		btnPanel.setLayout(new GridLayout());
		btnPanel.add(btnGraph);
		btnPanel.add(btnCancel);
		 c.gridy=21;
		add(btnPanel,c);
		btnCancel.addActionListener(cancelListener);
		btnPanel.revalidate();
		btnGraph.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent event){
				displayGraph();
			}
		});
		this.revalidate();
	}
	
	private void update(){
		System.out.println("sadfasd");
		String txt = htmlPane.getText();
		if(txt.indexOf("META")>=0){
			System.out.println("contains meta");
			txt = removeMeta(txt);
			htmlPane.setText(txt);
			htmlPane.setContentType("text/html");
		}
	}
	
	public void displayGraph(){
		System.out.println(htmlPane.getText());
		System.out.println(htmlPane.getPage());
		
		try{
			ChartGenerator generator = new ChartGenerator();
			JFrame f = new JFrame();
			f.setSize(400,400);
			Chart chart = generator.generateChart(dataModel);
			f.getContentPane().add(new javax.swing.JLabel(new javax.swing.ImageIcon(generator.render(chart))), java.awt.BorderLayout.CENTER);
		    f.pack();
		    f.show();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static void main(String argv[]){
		   JFrame frame = new JFrame("NN Test");
		   frame.setVisible(true);
		   frame.setSize(500, 500);
		  
		   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		   ResultsPanel nnPanel = new ResultsPanel(null);
		   frame.getContentPane().setLayout(new BorderLayout());
		   frame.getContentPane().add(nnPanel,BorderLayout.CENTER);
		   frame.validate();
	 }

	
	public void display(PredictorRunner runner){
		
		System.out.println("after the wait..");
		BufferedReader fin=null;
		try{
			fin=new BufferedReader(new  FileReader(runner.getResultFileName()));
			System.out.println(fin);
			String line =null;
			LinkedList list = new LinkedList();
			while(true){
				line = fin.readLine();
				if(line==null) break;
				Row row = new Row(line);
				Result result = new Result(row.getValue(0),
										row.getValue(1),
										row.getValue(2),
										row.getValue(3));
				list.add(result);
			}
			dataModel.setData(list);
			
		}catch(FileNotFoundException fe){
			fe.printStackTrace();
		}catch(IOException ioe){
			ioe.printStackTrace();
		}	finally{
			try{
				if(fin!=null) fin.close();
			}catch(Exception ignore){}
		}
		
		
	}
	
	public static String removeMeta (String html) {
	    boolean inHEAD = false;
	    boolean inMETA = false;
	    boolean endMETA = false;
	    boolean inQUOTE = false;
	    boolean startTAG = false;
	    boolean endTAG = false;
	    String key = "";
	    String back = "";
	    
	    StringBuffer b = new StringBuffer (html.length());
	    for (int i = 0; i < html.length(); i++) {
	      char c = html.charAt(i);
	      
	      if ( c == '"' ) inQUOTE = !inQUOTE;
	      
	      if ( c == '<' && !inQUOTE ) {
	        startTAG = true;
	      }
	      if ( c == '>' && !inQUOTE ) {
	        key = "";
	        if ( inMETA ) {
	          endMETA = true;
	        }
	      }
	      
	      if ( (c == ' ' || c == '>') && startTAG ) {
	        startTAG = false;
	        endTAG = true;
	      }
	      
	      if ( startTAG ) {
	        if ( c != '<' ) 
	          key += Character.toUpperCase(c);
	        back += c;
	        c = '\0';
	        System.out.println(key);
	      } 
	      
	      if ( endTAG && "META".equals(key) ) {
	        inMETA = true;
	        key = "";
	      }

	      // exit:
	      if ( endTAG && "BODY".equals(key) ) {
	        b.append(back);        
	        b.append(html.substring(i));
	        break;
	      }
	      
	      if ( inMETA ) {
	        back = "";
	        c = '\0';
	        if ( endMETA ) {
	          inMETA = false;
	          endMETA = false;
	        }
	      }
	      
	      if ( endTAG && !"META".equals(key) ) {
	        b.append(back);
	        back = "";        
	      }
	      
	      endTAG = false;
	      
	      if ( c != '\0' ) {
	        b.append(c);
	      }      
	    }
	    return b.toString();
	  }


}


