/*

* Copyright (c) 2003-2006 Illinois Institute of Technology.
* All rights reserved.
*
* This file is part of the NBP software package. For license
* information, see the LICENSE file in the top level directory of the
* NBP source distribution.
*
* Released Date: September 5 2006
* This is the NBP I release by the
* NBP Group,
* http://www.cs.iit.edu/~nbp
* Department of Computer Science,
* Illinois Institute of Technology.
*
* This release has been tested under Windows XP Professional
*
* Supervisor
* ----------
* Illiniois Institute of Technology:
* -Dr. Xian-He Sun
*
* Author(s)
* -----------------
* Illinois Institute of Technology:
* -Alaknantha Eswaradass
* -Ming Wu
* -Xian-He Sun
*
*/
import javax.swing.*;

import java.awt.*;

/**
  *
 * Nws monitor configuration panel. Contains all the parameters
 * needed by nws monitor
 */
public class NWSMonitorPanel extends JPanel{
	
	JLabel lblSource = new JLabel("Source Machine");
	JLabel lblDestination = new JLabel("Destination Machine");
	JLabel lblNumMeasurements = new JLabel("No. of Measurements");
	JLabel lblSkill = new JLabel("Skill to Monitor");
	JLabel lblPeriod = new JLabel("Period");
	JLabel lblDataSize = new JLabel("Total Data Size(in KB/s)");
	JLabel lblMessageSize = new JLabel("<html><body>Individual Send <br> message  size(in KB/s)</body></html>");
	JLabel lblBufferSize = new JLabel("Socket Buffer Size(in KB/s)");

	JTextField txtSource = new JTextField();
	JTextField txtDestination = new JTextField();
	JTextField txtNumMeasurements = new JTextField();
	JTextField txtSkill = new JTextField();
	JTextField txtPeriod = new JTextField();
	JTextField txtDataSize = new JTextField();
	JTextField txtMessageSize = new JTextField();
	JTextField txtBufferSize = new JTextField();
	
	public NWSMonitorPanel(){
		setPreferredSize(new Dimension(200,300));
		setMaximumSize(new Dimension(200,300));
		setLayout(new GridLayout(8,2,20,20));
		setBorder(BorderFactory.createTitledBorder("Network Traffic Monitor Inputs"));
		add(lblSource);
		add(txtSource);
		add(lblDestination);
		add(txtDestination);
		add(lblNumMeasurements);
		add(txtNumMeasurements);
		add(lblSkill);
		add(txtSkill);
		add(lblPeriod);
		add(txtPeriod);
		add(lblDataSize);
		add(txtDataSize);
		add(lblMessageSize);
		add(txtMessageSize);
		add(lblBufferSize);
		add(txtBufferSize);
		
	}
	
	public NWSMonitorConfig getConfig(){
		NWSMonitorConfig nwsConfig = new NWSMonitorConfig();
		nwsConfig.sourceMachine = txtSource.getText();
		nwsConfig.destMachine = txtDestination.getText();
		nwsConfig.noOfMeasurements = txtNumMeasurements.getText();
		nwsConfig.skillToMonitor = txtSkill.getText();
		nwsConfig.period = txtPeriod.getText();
		nwsConfig.totalDataSize = txtDataSize.getText();
		nwsConfig.sendMsgSize = txtMessageSize.getText();
		nwsConfig.socketBufferSize = txtBufferSize.getText();
		return nwsConfig;
	}
	
	public void setConfig(NWSMonitorConfig nwsConfig){
		txtSource.setText(nwsConfig.sourceMachine);
		txtDestination.setText(nwsConfig.destMachine);
		txtNumMeasurements.setText(nwsConfig.noOfMeasurements);
		txtSkill.setText(nwsConfig.skillToMonitor);
		txtPeriod.setText(nwsConfig.period);
		txtDataSize.setText(nwsConfig.totalDataSize);
		txtMessageSize.setText(nwsConfig.sendMsgSize);
		txtBufferSize.setText(nwsConfig.socketBufferSize);
	}
	
	public static void main(String argv[]){
		   JFrame frame = new JFrame("NN Test");
		   frame.setVisible(true);
		   frame.setSize(500, 500);
		  
		   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		   NWSMonitorPanel nnPanel = new NWSMonitorPanel();
		   frame.getContentPane().setLayout(new BorderLayout());
		   frame.getContentPane().add(nnPanel,BorderLayout.CENTER);
		   frame.validate();
	  }
	
}
