import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;


public class SSHConfigPanel extends JPanel {
	
    private JLabel lblServer = new JLabel("Server Name");
	private JLabel lblPort = new JLabel("Port");
	private JLabel lblUserName = new JLabel("UserName");
	private JLabel lblPassword = new JLabel("Password");
	
	private JTextField txtServerName= new JTextField();
	private JTextField txtPort= new JTextField();
	private JTextField txtUserName= new JTextField();
	private JTextField txtPassword =  new JTextField();
	
	
	private JButton btnConnect  = new JButton("Connect");
	private JButton btnCancel  = new JButton("Cancel");
	
	private SSHPanel sshPanel = null;
	
	private TitledBorder forcastBorder = null;
	public SSHConfigPanel(SSHPanel sshPanel){
		this.sshPanel=sshPanel;
		TitledBorder paramBorder = BorderFactory.createTitledBorder("SSH Configuration");
		Dimension dim = new Dimension(100,20);
		this.setBorder(paramBorder);
		this.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.gridwidth = 1;
        c.gridheight= 1;
        c.insets=new Insets(10, 10, 10, 10);
        c.gridx = 0; c.gridy=0;
		this.add(lblServer,c);
		c.gridx = 1; c.gridy=0;
		this.add(txtServerName,c);
		txtServerName.setPreferredSize(dim);
		txtServerName.setMaximumSize(dim);
		txtServerName.setMaximumSize(dim);
		this.revalidate();
		
		c.gridx = 0; c.gridy=1;
		this.add(lblPort,c);
		c.gridx = 1; c.gridy=1;
		this.add(txtPort,c);
		txtPort.setPreferredSize(dim);
		txtPort.setMaximumSize(dim);
		txtPort.setMaximumSize(dim);
		
		c.gridx = 0; c.gridy=2;
		this.add(lblUserName ,c);
		c.gridx = 1; c.gridy=2;
		this.add(txtUserName,c);
		txtUserName.setPreferredSize(dim);
		txtUserName.setMaximumSize(dim);
		txtUserName.setMaximumSize(dim);
	
		
		c.gridx = 0; c.gridy=3;
		this.add(lblPassword,c);
		c.gridx = 1; c.gridy=3;
		this.add(txtPassword,c);
		txtPassword.setPreferredSize(dim);
		txtPassword.setMaximumSize(dim);
		txtPassword.setMaximumSize(dim);
		//this.setPreferredSize(new Dimension(200,100));
		
		
		c.gridx = 0; c.gridy=4;
		this.add(btnConnect,c);
		c.gridx = 1; c.gridy=4;
		this.add(btnCancel,c);
		
		this.revalidate();
		

		btnConnect.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				SSHConfigPanel.this.sshPanel.connect();
			}
		});
		

		btnCancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				SSHConfigPanel.this.sshPanel.cancel();
			}
		});
		
		
	}
	
	
	
	public SSHConfig getConfig(){
		SSHConfig config = new SSHConfig();
		config.serverName = txtServerName.getText();
		config.password = txtPassword.getText();
		config.userName = txtUserName.getText();
		try{
			config.port=Integer.getInteger(txtPort.getText());
		}catch(Exception e){
			config.port=22; //default port
		}
			
		return config;
	}
	
	public void setConfig(SSHConfig config){
		txtServerName.setText(config.serverName);
		txtPassword.setText(config.password);
		txtUserName.setText(config.userName);
		txtPort.setText(config.port+"");
	}
	
	
	 public static void main(String argv[]){
		   JFrame frame = new JFrame("NN Test");
		   frame.setVisible(true);
		   frame.setSize(500, 500);
		  
		   frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		   SSHConfigPanel nnPanel = new SSHConfigPanel(null);
		   frame.getContentPane().setLayout(new BorderLayout());
		   frame.getContentPane().add(nnPanel,BorderLayout.CENTER);
		   frame.validate();
	   }	
}
